#include "RobotIF.h"

RobotIF::RobotIF(SimCore *sc)
{
	this->sc = sc;
}

RobotIF::~RobotIF()
{
}

void RobotIF::SetLeftMotorVel(double rps)
{
	sc->robot->SetLeftWheelVel(rps);
}

void RobotIF::SetRightMotorVel(double rps)
{
	sc->robot->SetRightWheelVel(rps);
}

long RobotIF::GetLeftEncoder()
{
	return sc->robot->GetLeftEncoder();
}

long RobotIF::GetRightEncoder()
{
	return sc->robot->GetRightEncoder();
}

double RobotIF::GetLeftCommandedVel()
{
	return sc->robot->GetLeftCommandedVel();
}

double RobotIF::GetRightCommandedVel()
{
	return sc->robot->GetRightCommandedVel();;
}

double RobotIF::GetLeftActualVel()
{
	return sc->robot->GetLeftActualVel();
}

double RobotIF::GetRightActualVel()
{
	return sc->robot->GetRightActualVel();
}

double RobotIF::GetAxleLength()
{
	return sc->robot->GetAxleLength();
}

double RobotIF::GetWheelRadius()
{
	return sc->robot->GetWheelRadius();
}

long RobotIF::GetTicksPerRevolution()
{
	return (long)sc->robot->GetTicksPerRevolution();
}

void RobotIF::SetWindowTitleExtra(const char *p)
{
	if(p == NULL || *p == 0) {
		sc->SetWindowSecondaryTitle("");
	} else {
		sc->SetWindowSecondaryTitle(p);
	}
}

void RobotIF::UpdateRobotPos()
{
	sc->GetRobotPosVec(robopos);
}

double RobotIF::GetSimulatorXPosition()
{
	UpdateRobotPos();
	return robopos[0];
}

double RobotIF::GetSimulatorYPosition()
{
	UpdateRobotPos();
	return robopos[1];
}

double RobotIF::GetSimulatorTPosition()
{
	UpdateRobotPos();
	return robopos[3];
}

