#ifndef __RobotIF_h__
#define __RobotIF_h__

#include "core.h"

class SimCore;

class RobotIF {
public:
	RobotIF(SimCore *sc);
	~RobotIF();

	void SetLeftMotorVel(double rps);
	void SetRightMotorVel(double rps);

	long GetLeftEncoder();
	long GetRightEncoder();

	double GetLeftCommandedVel();
	double GetRightCommandedVel();

	double GetLeftActualVel();
	double GetRightActualVel();

	double GetAxleLength();
	double GetWheelRadius();
	long GetTicksPerRevolution();

	void SetWindowTitleExtra(const char *);

	/* ground truth */
	double GetSimulatorXPosition();
	double GetSimulatorYPosition();
	double GetSimulatorTPosition();

private:
	SimCore *sc;

	double robopos[4];
	void UpdateRobotPos();
};

#endif
