#ifndef __Target_h__
#define __Target_h__

#include "Object.h"

using namespace std;

class Target : public Object {
public:
	Target(double x, double y, double radius, double r, double g, double b);
	virtual ~Target();
	virtual int GetType() { return OBJECT_TARGET; }
	virtual void Draw();
	virtual void SetupODE(dWorldID, dSpaceID);
	virtual void SetupGL();
	virtual void UpdatePositions();
	virtual int UpdatePhysics();
	virtual int HandleCollision(dGeomID you, int wp, Object *other, dSurfaceParameters &surface);

	bool IsHit() { return hit; }
	bool IsDead() { return destroyed; }

private:
	double radius;
	double r, g, b;
	
	dBodyID target_body;
	bool enable_movable;
	bool hit;
	bool destroyed;
	GLUquadric *q;
	GLuint texture_id;
};

#endif
